// AacConverter.h: CAacConverter NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "MediaDecoder.h"
#include "AacDecoder.h"


/////////////////////////////////////////////////////////////////////////////
// AACfR[_(AACPCMɃfR[h)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CAdtsFrame		̓f[^
// Output	#0	: CMediaData		o̓f[^
/////////////////////////////////////////////////////////////////////////////

class CAacConverter : public CMediaDecoder  
{
public:
	CAacConverter(CDecoderHandler *pDecoderHandler);
	virtual ~CAacConverter();

// IMediaDecoder
	virtual void Reset(void);
	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CAacConverter
	const BYTE GetLastChannelNum(void) const;

	//	p[^[

	const BYTE GetOutputChannel(void) const;
	void	SetOutputChannel(const BYTE byChannel);

protected:
	static void CALLBACK OnLpcmFrame(const BYTE *pData, const DWORD dwSamples, const BYTE byChannel, PVOID pParam);

	CAacDecoder m_AacDecoder;
	CMediaData m_PcmBuffer;

	BYTE m_byLastChannelNum;

	BYTE m_byOutputChannel;

private:
	static const DWORD DownMixMono(short *pDst, const short *pSrc, const DWORD dwSamples);
	static const DWORD DownMixStreao(short *pDst, const short *pSrc, const DWORD dwSamples);
	static const DWORD DownMixSurround(short *pDst, const short *pSrc, const DWORD dwSamples);

	static const DWORD UpMixMono(short *pDst, const short *pSrc, const DWORD dwSamples);
	static const DWORD UpMixStreao(short *pDst, const short *pSrc, const DWORD dwSamples);
	static const DWORD UpMixSurround(short *pDst, const short *pSrc, const DWORD dwSamples);
};
